Index: trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 491)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.h	(revision 492)
@@ -264,4 +264,7 @@
 	BspNode *CollapseTree(BspNode *node);
 
+  ViewCell *
+  GetViewCell(const Vector3 &point);
+
 	/** Constructs bsp rays for post processing and visualization.
 	*/
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Pvs.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Pvs.h	(revision 485)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Pvs.h	(revision 492)
@@ -60,4 +60,6 @@
   */
   PvsData<T> *Find(T sample);
+
+  bool GetSampleContribution(T sample, float &contribution);
   
   /** Adds sample to PVS. 
@@ -71,5 +73,5 @@
   */
   int AddSample(T sample);
-
+  
   /** Adds one pvs to another one.
 	  @returns new pvs size
@@ -157,12 +159,21 @@
 
 template <typename T>
-int Pvs<T>::AddSample(T sample)
-{
-  float dummy;
-  return AddSample(sample, dummy) ? 1 : 0;
-}
-
-template <typename T>
-bool Pvs<T>::AddSample(T sample, float &contribution)
+int
+Pvs<T>::AddSample(T sample)
+{
+  PvsData<T> *data = Find(sample);
+  
+  if (data)  {
+	return ++data->mVisibleSamples;
+  }
+  else {
+	mEntries[sample] = PvsData<T>(1);
+	return 1;
+  }
+}
+
+template <typename T>
+bool
+Pvs<T>::AddSample(T sample, float &contribution)
 {
   PvsData<T> *data = Find(sample);
@@ -181,4 +192,20 @@
 
 template <typename T>
+bool
+Pvs<T>::GetSampleContribution(T sample, float &contribution) 
+{
+  PvsData<T> *data = Find(sample);
+  
+  if (data)  {
+	contribution = 1.0f/(data->mVisibleSamples + 1);
+	return false;
+  }
+  else {
+	contribution = 1.0f;
+	return true;
+  }
+}
+
+template <typename T>
 bool Pvs<T>::RemoveSample(T sample, const int visibleSamples)
 {
Index: trunk/VUT/GtpVisibilityPreprocessor/src/PreprocessorThread.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/PreprocessorThread.h	(revision 492)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/PreprocessorThread.h	(revision 492)
@@ -0,0 +1,26 @@
+#ifndef __PREPROCESSOR_THREAD_H
+#define __PREPROCESSOR_THREAD_H
+
+#include <QThread>
+
+class Preprocessor;
+
+class PreprocessorThread : public QThread
+{
+  Q_OBJECT
+
+  Preprocessor *mPreprocessor;
+public:
+  PreprocessorThread(Preprocessor *p, QObject *parent = 0);
+  ~PreprocessorThread() {}
+
+  void Main();
+
+protected:
+  void run() {
+	Main();
+  }
+};
+
+
+#endif
Index: trunk/VUT/GtpVisibilityPreprocessor/src/SceneGraph.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/SceneGraph.h	(revision 387)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/SceneGraph.h	(revision 492)
@@ -16,4 +16,5 @@
   SceneGraphNodeContainer mChildren;
   AxisAlignedBox3 mBox;
+  void UpdateBox();
 };
 
@@ -27,12 +28,14 @@
   
   int
-	CollectObjects(ObjectContainer *instances);
-	
+  CollectObjects(ObjectContainer *instances);
+  
   int
-	AssignObjectIds();
+  AssignObjectIds();
+  
+  void
+  GetStatistics(int &intersectables, int &faces) const;
 
-	void
-	GetStatistics(int &intersectables, int &faces) const;
-
+  AxisAlignedBox3 GetBox() const { return mRoot->mBox; }
+  
 protected:
 };
@@ -40,4 +43,3 @@
 
 
-
 #endif
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 491)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.h	(revision 492)
@@ -468,4 +468,7 @@
 				  );
 
+  ViewCell *
+  GetViewCell(const Vector3 &point);
+  
 	/// bsp tree construction types
 	enum {FROM_INPUT_VIEW_CELLS, FROM_SCENE_GEOMETRY, FROM_SAMPLES};
Index: trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.h	(revision 487)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.h	(revision 492)
@@ -68,4 +68,5 @@
   }
 
+
   void SetMin(const Vector3 &v) {
     mMin = v;
@@ -142,4 +143,11 @@
   bool IsPoint() const;
 
+  void Scale(const float scale) {
+	Vector3 newSize = Size()*(scale*0.5f);
+	Vector3 center = Center();
+	mMin = center - newSize;
+	mMax = center + newSize;
+  }
+  
   void
   GetSqrDistances(const Vector3 &point,
@@ -181,5 +189,10 @@
 													RandomValue(0, size.z)); 
   }
-  
+
+
+  Vector3 GetPoint(const Vector3 &p) const {
+    return mMin + p*Size(); 
+  }
+
   // Returns the smallest axis-aligned box that includes all points
   // inside the two given boxes.
@@ -208,10 +221,19 @@
 		ID_Right = 4, ID_Top = 5};
   
+  int
+  ComputeMinMaxT(const Vector3 &origin,
+				 const Vector3 &direction,
+				 float *tmin,
+				 float *tmax) const;
+	
   // Compute tmin and tmax for a ray, whenever required .. need not pierce box
   int ComputeMinMaxT(const Ray &ray, float *tmin, float *tmax) const;
 
   // Compute tmin and tmax for a ray, whenever required .. need not pierce box
-  int ComputeMinMaxT(const Ray &ray, float *tmin, float *tmax,
-		     EFaces &entryFace, EFaces &exitFace) const;
+  int ComputeMinMaxT(const Ray &ray,
+					 float *tmin,
+					 float *tmax,
+					 EFaces &entryFace,
+					 EFaces &exitFace) const;
   
   // If a ray pierces the box .. returns 1, otherwise 0.
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Halton.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Halton.h	(revision 355)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Halton.h	(revision 492)
@@ -2,40 +2,129 @@
 #define __HALTON_H
 
+#include <iostream>
+using namespace std;
+
 class Halton2 {
-	
-	float _invBases[2];
-	float _prev[2];
+  static float _invBases[2];
+  float _prev[2];
+  
+  float halton(float baseRec, float prev) const {
+	float r = 1 - prev - 1e-10;
+	if (baseRec < r)
+	  return prev + baseRec;
+	float h = baseRec;
+	float hh;
+	do {
+	  hh = h;
+	  h *= baseRec;
+	} while (h >= r);
+	return prev + hh + h - 1;
+  }
+  
+public:
+  
+  void Reset() {
+	_prev[0] =_prev[1] = 0;
+  }
+  
+  Halton2() {
+	_invBases[0] = 1./2;
+	_invBases[1] = 1./3;
+	Reset();
+  }
+  
+  void
+  GetNext(float &a, float &b) {
+	a = halton(_invBases[0], _prev[0]);
+	b = halton(_invBases[1], _prev[1]);
+	_prev[0] = a;
+	_prev[1] = b;
+  }
+};
 
-	float halton(float baseRec, float prev) const {
-		float r = 1 - prev - 1e-10;
-		if (baseRec < r) return prev + baseRec;
-		float h = baseRec;
-		float hh;
-		do {
-			hh = h;
-			h *= baseRec;
-		} while (h >= r);
-		return prev + hh + h - 1;
+
+/**
+ * Assert whether the argument is a prime number.
+ * @param number the number to be checked
+ */
+inline bool IsPrime(const int number) {
+  bool isIt = true;
+  for(int i = 2; i < number; i++) {
+	if(number % i == 0) {
+	  isIt = false;
+	  break;
 	}
-	
+  }
+	if(number == 2) {
+	  isIt = false;
+	}
+	return isIt;
+}
+
+/**
+ * Find the nth prime number.
+ * @param index the ordinal position in the sequence
+ */
+inline int FindPrime(const int index) {
+  if(index < 1) {
+	cerr<<"FindPrime: The argument must be non-negative."<<endl;
+	return -1;
+  }
+  int prime = 1;
+  int found = 1;
+  while(found != index) {
+	prime += 2;
+	  if(IsPrime(prime) == true) {
+		found++;
+	  }
+  }
+  return prime;
+}
+
+struct HaltonSequence {
 public:
+  int index;
 
-	void Reset() {
-		_prev[0] =_prev[1] = 0;
+  HaltonSequence():index(1) {}
+
+  void Reset() {
+	index = 1;
+  }
+
+  void GenerateNext() {
+	index++;
+  }
+  
+  /**
+   * Returns the nth number in the sequence, taken from a specified dimension.
+   * @param index the ordinal position in the sequence
+   * @param dimension the dimension
+   */
+
+  double GetNumber(const int dimension)  {
+	int base = FindPrime(dimension);
+	if(base == 1) {
+	  base++;  //The first dimension uses base 2.
+	} 
+	double remainder;
+	double output = 0.0;
+	double fraction = 1.0 / (double)base;
+	int N1 = 0;
+	int copyOfIndex = index;
+	if(base >= 2 & index >= 1) {
+	  while(copyOfIndex > 0) {
+		N1 = (copyOfIndex / base);
+		remainder = copyOfIndex % base;
+		output += fraction * remainder;
+		copyOfIndex = (int)(copyOfIndex / base);
+		fraction /= (double)base;
+	  } 
+	  return output;
 	}
-
-	Halton2() {
-		_invBases[0] = 1./2;
-		_invBases[1] = 1./3;
-		Reset();
+	else {
+	  cerr<<"Error generating Halton sequence."<<endl;
+	  exit(1);
 	}
-	
-	void
-	GetNext(float &a, float &b) {
-		a = halton(_invBases[0], _prev[0]);
-		b = halton(_invBases[1], _prev[1]);
-		_prev[0] = a;
-		_prev[1] = b;
-	}
+  }
 };
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.h	(revision 448)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.h	(revision 492)
@@ -228,4 +228,7 @@
 
   friend Vector3 UniformRandomVector(const Vector3 &normal);
+  friend Vector3 UniformRandomVector();
+  
+
 };
 
@@ -445,4 +448,5 @@
 }
 
+
 // Overload << operator for C++-style output
 inline ostream&
Index: trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.h	(revision 469)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.h	(revision 492)
@@ -21,4 +21,5 @@
 #include "VssRay.h"
 #include "AxisAlignedBox3.h"
+#include "Halton.h"
 
 
@@ -69,5 +70,17 @@
   // number of dynamically removed ray refs
   int removedRayRefs;
-  
+
+
+
+  // dynamically updated values
+  float avgPvsSize;
+  float avgRays;
+  float avgRayContribution;
+  float avgPvsEntropy;
+  float avgRayLengthEntropy;
+  float avgImportance;
+
+  float avgWeightedRayContribution;
+
   // Constructor
   RssStatistics() {
@@ -144,20 +157,75 @@
 	  return a.mRay < b.mRay;
 	}
+
+#define USE_ORIGIN 0
 	
 	Vector3 GetOrigin() const {
+#if USE_ORIGIN
 	  return mRay->GetOrigin();
-	}
-
-	float ExtrapOrigin(const int axis) const {
+#else
+	  return mRay->GetTermination();
+#endif
+	}
+
+	Vector3 GetTermination() const {
+#if USE_ORIGIN
+	  return mRay->GetTermination();
+#else
+	  return mRay->GetOrigin();
+#endif
+	}
+
+	float GetOrigin(const int axis) const {
+#if USE_ORIGIN
 	  return mRay->GetOrigin(axis);
-	}
-	
-	float ExtrapTermination(const int axis) const {
+#else
 	  return mRay->GetTermination(axis);
-	}
-
-	Vector3 Extrap(const float t) const {
-	  return mRay->Extrap(t);
-	}
+#endif
+	}
+
+	Vector3 GetDir() const {
+#if USE_ORIGIN
+	  return mRay->GetDir();
+#else
+	  return -mRay->GetDir();
+#endif
+	}
+
+	float GetDirParametrization(const int axis) const {
+#if USE_ORIGIN
+	  return mRay->GetDirParametrization(axis);
+#else
+	  return mRay->GetOpositeDirParametrization(axis);
+#endif
+	}
+
+	
+// 	Vector3 GetTermination() const {
+// 	  return mRay->GetOrigin();
+// 	}
+	
+// 	float GetTermination(const int axis) const {
+// 	  return mRay->GetTermination(axis);
+// 	}
+
+	Intersectable *GetObject() const {
+#if USE_ORIGIN
+	  return mRay->mTerminationObject;
+#else
+	  return mRay->mOriginObject;
+#endif
+	}
+	
+	Intersectable *GetSourceObject() const {
+#if USE_ORIGIN
+	  return mRay->mOriginObject;
+#else
+	  return mRay->mTerminationObject;
+#endif
+	}
+
+	//	Vector3 Extrap(const float t) const {
+	//	  return mRay->Extrap(t);
+	//	}
 	
 	int
@@ -167,8 +235,46 @@
 	  
 	  // only compare the side of the origin
-	  float rpos = mRay->GetOrigin(axis);
+	  float rpos = (axis < 3) ? GetOrigin(axis) : GetDirParametrization(axis - 3);
 	  return (rpos <= position) ? -1 : 1;
 	}
-	
+
+	static bool GreaterWeightedPvsContribution(const RayInfo &a,
+											   const RayInfo &b) {
+	  return a.mRay->mWeightedPvsContribution > b.mRay->mWeightedPvsContribution;
+	}
+
+	static float Distance(const RayInfo &a,
+						 const RayInfo &b)
+	{
+	  if (a.mRay->mTerminationObject == b.mRay->mTerminationObject)
+		return MAX_FLOAT;
+	  
+	  return Min(a.mRay->SqrDistance(b.GetTermination()),
+				 b.mRay->SqrDistance(a.GetTermination()));
+	}
+
+	
+	static float SqrDistance5D(const RayInfo &a,
+							   const RayInfo &b,
+							   const Vector3 &spatialDerivative,
+							   const Vector3 &directionalDerivative
+							   )
+	{
+	  Vector3 spatialDiff = b.GetOrigin() - a.GetOrigin();
+	  Vector3 directionalDiff = b.GetDir() - a.GetDir();
+	  
+	  return DotProd(spatialDiff, spatialDerivative) +
+		DotProd(directionalDiff, directionalDerivative);
+	}
+
+	
+  };
+
+  struct SilhouetteRays {
+	RayInfo *a;
+	RayInfo *b;
+	SilhouetteRays() {}
+	SilhouetteRays(RayInfo *_a, RayInfo *_b):a(_a), b(_b) {
+	}
   };
   
@@ -307,15 +413,14 @@
   
   RayInfoContainer rays;
-  int mPassingRays;
+  int mTotalRays;
 	
   bool mValidPvs;
-  float mEntropyImportance;
-  float mPvsEntropy;
-  float mRayLengthEntropy;
-  
-	
+  float mImportance;
+  
+  HaltonSequence halton;
+  
   RssTreeLeaf(RssTreeInterior *p,
 			  const int nRays
-			  ):RssTreeNode(p), rays(), mPvsSize(0), mPassingRays(0), mValidPvs(false) {
+			  ):RssTreeNode(p), rays(), mPvsSize(0), mTotalRays(0), mValidPvs(false) {
     rays.reserve(nRays);
   }
@@ -328,5 +433,5 @@
     s<<
 	  "L: rays="<<(int)rays.size()<<
-	  " pvs="<<mPvsSize<<" pEntropy="<<mPvsEntropy<<" lEntropy="<<mRayLengthEntropy<<endl;
+	  " pvs="<<mPvsSize<<" importance="<<mImportance<<endl;
   };
   
@@ -334,7 +439,6 @@
 	mValidPvs = false;
     rays.push_back(data);
-    data.mRay->Ref();
-	if (data.GetRayClass() == RayInfo::PASSING_RAY)
-	  mPassingRays++;
+	mTotalRays++;
+	data.mRay->Ref();
   }
 	
@@ -348,18 +452,20 @@
   }
 
-  void
-  UpdatePvsSize();
 
   float
-  ComputePvsEntropy();
+  ComputePvsEntropy() const;
   
   float
-  ComputeRayLengthEntropy();
+  ComputeRayLengthEntropy() const;
   
   float
-  ComputeRayTerminationEntropy();
-  
-  void
-  ComputeEntropyImportance();
+  ComputeRayTerminationEntropy() const;
+  
+
+  float
+  ComputeEntropyImportance() const;
+  
+  float
+  ComputeRayContributionImportance() const;
 
   void Mail() { mailbox = mailID; }
@@ -401,4 +507,5 @@
 	return a->GetAvgRayContribution() > b->GetAvgRayContribution();
   }
+
   
 };
@@ -560,4 +667,7 @@
   // depth at which directional splits are performed if mInterleaveDirSplits is false
   int mDirSplitDepth;
+
+  // maximal number of rays maintained in the rss tree
+  int mMaxRays;
   
   // maximal size of the box on which the refdir splitting can be performed
@@ -582,4 +692,8 @@
   int minCollapseDepth;
 
+  bool mImportanceBasedCost;
+
+  // sampling pass
+  int mCurrentPass;
   
   // reusable array of split candidates
@@ -627,13 +741,4 @@
   Subdivide(const TraversalData &tdata);
 	
-  int
-  SelectPlane(RssTreeLeaf *leaf,
-			  const AxisAlignedBox3 &box,
-			  float &position,
-			  int &raysBack,
-			  int &raysFront,
-			  int &pvsBack,
-			  int &pvsFront
-			  );
 
   void
@@ -658,49 +763,87 @@
   }
   
-
-  float
+  struct SplitInfo {
+	
+	int axis;
+	float position;
+	float costRatio;
+	
+	int rays;
+	int raysBack;
+	int raysFront;
+
+	int pvs;
+	int pvsBack;
+	int pvsFront;
+
+	float contribution;
+	float contributionBack;
+	float contributionFront;
+
+	int viewCells;
+	int viewCellsBack;
+	int viewCellsFront;
+
+	float volume;
+	float volumeBack;
+	float volumeFront;
+	
+  };
+  
+  void
   BestCostRatio(
 				RssTreeLeaf *node,
-				int &axis,
-				float &position,
-				int &raysBack,
-				int &raysFront,
-				int &pvsBack,
-				int &pvsFront
+				SplitInfo &info
+// 				int &axis,
+// 				float &position,
+// 				int &raysBack,
+// 				int &raysFront,
+// 				int &pvsBack,
+// 				int &pvsFront
 				);
 	
-  float
+  
+  void
   EvalCostRatio(
 				RssTreeLeaf *node,
-				const int axis,
-				const float position,
-				int &raysBack,
-				int &raysFront,
-				int &pvsBack,
-				int &pvsFront
+				SplitInfo &info
+// 				const int axis,
+// 				const float position,
+// 				int &raysBack,
+// 				int &raysFront,
+// 				int &pvsBack,
+// 				int &pvsFront
 				);
 
-  float
+  void
   EvalCostRatioHeuristic(
 						 RssTreeLeaf *node,
-						 const int axis,
-						 float &position,
-						 int &raysBack,
-						 int &raysFront,
-						 int &pvsBack,
-						 int &pvsFront
+						 SplitInfo &info
+// 						 const int axis,
+// 						 float &position,
+// 						 int &raysBack,
+// 						 int &raysFront,
+// 						 int &pvsBack,
+// 						 int &pvsFront
 						 );
 
-  float
+  int
+  SelectPlane(RssTreeLeaf *leaf,
+			  const AxisAlignedBox3 &box,
+			  SplitInfo &info
+			  );
+  
+  void
   GetCostRatio(
 			   RssTreeLeaf *leaf,
-			   const int axis,
-			   const float position,
-			   const int raysBack,
-			   const int raysFront,
-			   const int pvsBack,
-			   const int pvsFront
+			   SplitInfo &info
+			   // 			   const int axis,
+			   // 			   const float position,
+			   // 			   const int raysBack,
+			   // 			   const int raysFront,
+			   // 			   const int pvsBack,
+			   // 			   const int pvsFront
 			   );
-
+  
   AxisAlignedBox3 GetBBox(const RssTreeNode *node) const {
     if (node->parent == NULL)
@@ -803,12 +946,5 @@
 	
   void
-  GetTreeStatistics(
-					float &avgPvsSize,
-					float &avgRays,
-					float &avgRayContribution,
-					float &avgPvsEntropy,
-					float &avgRayLengthEntropy,
-					float &avgImportance
-					);
+  UpdateTreeStatistics();
 
 
@@ -865,4 +1001,55 @@
 			  );
 
+  void
+  UpdatePvsSize(RssTreeLeaf *leaf);
+
+  void
+  ComputeImportance(RssTreeLeaf *leaf);
+  
+  void
+  SetPass(const int p) {
+	mCurrentPass = p;
+  }
+  
+  void GetRayContribution(const RssTreeNode::RayInfo &info,
+						  float &weight,
+						  float &contribution);
+
+  float
+  GetSampleWeight(const int pass);
+
+  int
+  RemoveInteriorRays(
+					 RssTreeLeaf *leaf
+					 );
+
+  bool
+  IsRayConvexCombination(const RssTreeNode::RayInfo &ray,
+						 const RssTreeNode::RayInfo &r1,
+						 const RssTreeNode::RayInfo &r2,
+						 const RssTreeNode::RayInfo &r3);
+
+  int
+  PruneRays(RssTreeLeaf *leaf,
+			const float contributionThreshold);
+  int
+  PruneRaysRandom(RssTreeLeaf *leaf,
+				  const float ratio);
+
+  int
+  PruneRaysContribution(RssTreeLeaf *leaf,
+						const float ratio);
+
+  int
+  PruneRays(
+			const int desired
+			);
+  
+
+  void
+  FindSilhouetteRays(RssTreeLeaf *leaf,
+					 vector<RssTreeLeaf::SilhouetteRays> &rays
+					 );
+  
 };
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Camera.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Camera.h	(revision 469)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Camera.h	(revision 492)
@@ -6,4 +6,5 @@
 
 class KdTree;
+class SceneGraph;
 
 class Camera
@@ -22,6 +23,6 @@
   
   Camera() {
-    mWidth = 640;
-    mHeight = 480;
+    mWidth = 1400;
+    mHeight = 1000;
     mFovy = 60.0f*(float)M_PI/180.0f;
   }
@@ -63,5 +64,8 @@
   
   bool
-  SnapImage(string filename, KdTree *tree);
+  SnapImage(string filename,
+			KdTree *tree,
+			SceneGraph *sceneGraph
+			);
 
   void SetupRay(Ray &ray, const int x, const int y);
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 490)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 492)
@@ -171,5 +171,9 @@
 	virtual void GetPvsStatistics(PvsStatistics &stat);
 
-	virtual void PrintPvsStatistics(ostream &s);
+  /** Get a viewcell containing the specified point */
+  virtual ViewCell *GetViewCell(const Vector3 &point) = 0;
+  
+  virtual void
+  PrintPvsStatistics(ostream &s);
 
 	/** Returns probability that view point lies in one view cell.
@@ -339,4 +343,7 @@
 	AxisAlignedBox3 GetSceneBbox() const;
 
+  /** Get a viewcell containing the specified point */
+  ViewCell *GetViewCell(const Vector3 &point) { return NULL; }
+
 protected:
 
@@ -404,10 +411,11 @@
 	/** Prints out statistics of this approach.
 	*/
-	//void PrintStatistics(ostream &s) const;
-
-	float GetProbability(ViewCell *viewCell);
-	float GetRendercost(ViewCell *viewCell, float objRendercost) const;
-	
-	AxisAlignedBox3 GetSceneBbox() const;
+  //  virtual void PrintStatistics(ostream &s) const;
+  ViewCell *GetViewCell(const Vector3 &point) { return NULL; }
+
+  float GetProbability(ViewCell *viewCell);
+  float GetRendercost(ViewCell *viewCell, float objRendercost) const;
+  
+  AxisAlignedBox3 GetSceneBbox() const;
 
 protected:
@@ -460,9 +468,10 @@
 						ViewCellContainer &viewcells);
 
+  ViewCell *GetViewCell(const Vector3 &point) { return NULL; }
+
 	float GetProbability(ViewCell *viewCell);
 	float GetRendercost(ViewCell *viewCell, float objRendercost) const;
 
 	AxisAlignedBox3 GetSceneBbox() const;
-
 protected:
 
@@ -508,5 +517,4 @@
 	bool ViewCellsConstructed() const;
 
-	//void PrintStatistics(ostream &s) const;
 	
 	int CastLineSegment(const Vector3 &origin,
@@ -519,8 +527,9 @@
 	AxisAlignedBox3 GetSceneBbox() const;
 
+  ViewCell *GetViewCell(const Vector3 &point);
+
 	bool GetViewPoint(Vector3 &viewPoint) const;
 
 	bool ViewPointValid(const Vector3 &viewPoint) const;
-
 protected:
 	/** DEPRECATED
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 491)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VspBspTree.cpp	(revision 492)
@@ -1525,29 +1525,34 @@
 void VspBspTree::CollectViewCells(ViewCellContainer &viewCells) const
 {
-	stack<BspNode *> nodeStack;
-	nodeStack.push(mRoot);
-
-	ViewCell::NewMail();
-
-	while (!nodeStack.empty())
-	{
-		BspNode *node = nodeStack.top();
-		nodeStack.pop();
-
-		if (node->IsLeaf())
-		{
-			ViewCell *viewCell = dynamic_cast<BspLeaf *>(node)->GetViewCell();
-			if (node->TreeValid() && !viewCell->Mailed())
+  stack<BspNode *> nodeStack;
+
+  if (!mRoot)
+	return;
+
+  nodeStack.push(mRoot);
+  
+  ViewCell::NewMail();
+  
+  while (!nodeStack.empty()) 
+	{
+	  BspNode *node = nodeStack.top();
+	  nodeStack.pop();
+	  
+	  if (node->IsLeaf()) 
+		{
+		  ViewCell *viewCell = dynamic_cast<BspLeaf *>(node)->GetViewCell();
+		  
+		  if (!viewCell->Mailed()) 
 			{
-				viewCell->Mail();
-				viewCells.push_back(viewCell);
+			  viewCell->Mail();
+			  viewCells.push_back(viewCell);
 			}
 		}
 		else
 		{
-			BspInterior *interior = dynamic_cast<BspInterior *>(node);
-
-			nodeStack.push(interior->GetFront());
-			nodeStack.push(interior->GetBack());
+		  BspInterior *interior = dynamic_cast<BspInterior *>(node);
+		  
+		  nodeStack.push(interior->GetFront());
+		  nodeStack.push(interior->GetBack());
 		}
 	}
@@ -2504,4 +2509,38 @@
 
 
+ViewCell *
+VspBspTree::GetViewCell(const Vector3 &point)
+{
+  if (mRoot == NULL)
+	return NULL;
+  
+  stack<BspNode *> nodeStack;
+  nodeStack.push(mRoot);
+  
+  ViewCell *viewcell = NULL;
+  
+  while (!nodeStack.empty())  {
+	BspNode *node = nodeStack.top();
+	nodeStack.pop();
+	
+	if (node->IsLeaf()) {
+	  viewcell = dynamic_cast<BspLeaf *>(node)->GetViewCell();
+	  break;
+	} else {
+	  
+	  BspInterior *interior = dynamic_cast<BspInterior *>(node);
+		
+	  // random decision
+	  if (interior->GetPlane().Side(point) < 0)
+		nodeStack.push(interior->GetBack());
+	  else
+		nodeStack.push(interior->GetFront());
+	}
+  }
+  
+  return viewcell;
+}
+
+
 int VspBspTree::RefineViewCells(const VssRayContainer &rays)
 {
